#include <templates.h>

void *t_validate_string(char *token, p_kv opts)
{
	return strdup(token);
}

void *t_validate_number(char *token, p_kv opts)
{
	p_num_priv p;
	if ( !token ) return NULL;

	if ( !(p=malloc(sizeof(num_priv_t))) ) return NULL;

	p->val = atoi(token);
	return p;
}

void *t_validate_range(char *token, p_kv opts)
{
	p_range_priv priv=NULL;
	char *min=NULL, *max=NULL;
	char *tmp;
	
	if ( !token ) return NULL;

	if ( !(priv=malloc(sizeof(range_priv_t))) ) {
		return NULL;
	}

	if ( !(tmp=malloc(strlen(token)+1)) ) {
		free(priv);
		return;
	}

	strcpy(tmp, token);
	min=tmp;

	if ( (max=strchr(tmp, ':')) ) {
		*max='\0';
		max++;
	}else{
		max=min;
	}

	priv->min=atoi(min);
	priv->max=atoi(max);
	
	free(tmp);
	return (void *)priv;
}

void t_cleanup_ptr(void *priv)
{
	if ( priv ) free(priv);
}

void template_fill_struct(p_tmpl p)
{
	if ( !p ) return;

	p->t_validate_range=t_validate_range;
	p->t_validate_string=t_validate_string;
	p->t_validate_number=t_validate_number;
	
	p->t_cleanup_ptr=t_cleanup_ptr;
}
